;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                ;;
;;            EDIT III            ;;
;;                                ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  Compile with flat assembler   ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; 5409 - without macro
; 5204 - with macro
include 'macros.inc'

use32

   org   0x0
   db    'MENUET01'  ; identifier
   dd    0x01        ; version
   dd    START       ; pointer to start
   dd    IMAGE_END   ; size of file
   dd    0x300000    ; size of memory
   dd    0xfff0      ; esp
   dd    I_PARAM     ; parameters
;  dd    0           ; icon

;
;  Memory 0x300000
;
;  stack            0x00fff0 +
;  load position    0x010000 +
;  screen comp      0x078000 +
;  edit area        0x080000 +
;  copy/paste area  0x2f0000 +
;


START:
    cmp       [I_PARAM],byte 0
    jz        noparams

    mov       esi,I_PARAM
    mov       edi,filename
    mov       ecx,12
    cld
    rep       movsb

;    xor       eax,eax
;    xor       ebx,ebx
;    mov       ecx,10
;    mov       edi,I_PARAM+12
;    mov       byte [edi+6],al
; nextdigit:
;    cmp       byte [edi],0
;    je        numberOK
;    mov       bl,byte [edi]
;    add       bl,-'0'
;    mul       ecx
;    add       eax,ebx
;    inc       edi
;    jmp       nextdigit
;  numberOK:
;    mov       ecx,80
;    mul       ecx
;    mov       [fline],eax

  noparams:

    call      loadfile
    call      drawwindow



; ****** WAIT LOOP ******

still:

    call writepos

    mov  eax,10                 ; wait here until event
    int  0x40

    dec  eax                    ; redraw ?
    jz   red
    dec  eax                    ; key ?
    jz   key
    dec  eax                    ; button ?
    jz   button

    jmp  still


  button:

    mov  eax,17
    int  0x40

    cmp  ah,50            ; search
    jne  no_search
    xor  esi,esi
    mov  edi,[post]
    add  edi,80
    mov  ecx,[lines]
    imul ecx,80
    sub  ecx,edi
  news:
    push edi
  news2:
    mov  al,[esi+search_string]
    mov  bl,[edi+0x80000]
    cmp  al,bl
    je   yes_char
    cmp  al,'A'
    jb   nof
    cmp  al,'z'
    ja   nof   ; russian

    cmp  al,'a'
    jb   @f
    add  al,-32
    jmp  gogogo
  @@:
    cmp  al,'Z'
    ja   nof
    add  al,32
  gogogo:
    cmp  al,bl
    jne  nof
  yes_char:
    inc  edi
    inc  esi
    cmp  esi,[search_s_length]
    jge  sfound
    jmp  news2
  nof:
    pop  edi
    xor  esi,esi
    inc  edi
    loop news
    jmp  still
  sfound:
    xor  edx,edx
    mov  eax,edi
    mov  ebx,80
    div  ebx
    imul eax,80

    mov  [post],eax
    call drawfile
    jmp  still
  no_search:

    cmp  ah,4
    jnz  noid4
    call empty_work_space

    cmp [filename],'/'
    jne @f

    call loadhdfile
    jmp  restorecursor
@@:
    call loadfile
  restorecursor:
    mov  edi,0x78000
    mov  ecx,80*80
    xor  eax,eax
    inc  eax
    cld
    rep  stosb
    mov  [post],dword 0
    mov  [posx],dword 0
    mov  [posy],dword 0
    call drawfile
    jmp  still
  noid4:

    mov  [savetohd],dword 0

    cmp  ah,2
    jz   yessave

    dec  ah
    jnz  nosave
    xor  eax,eax
    dec  eax
    int  0x40

savetohd dd 0x0

  yessave:

    cmp  byte [filename],'/'
    jne  @f
    mov  [savetohd],1
@@:
    mov  [filelen],dword 0x0
    mov  [fileslines],dword 0x0

    mov  ebx,0x80000+80
    xor  edx,edx
    mov  ecx,0x10000

  sdonewline:

    mov  esi,ebx

  sdoline:

    dec  esi
    cmp  [esi],byte ' '
    jnz  slinefound

    mov  eax,ebx
    add  eax,-80
    cmp  eax,esi
    jnz  sdoline

    dec  esi   ; (!!!) add  esi,2

  slinefound:

    mov  edi,ecx ; edi = write position

    push ecx

    mov  ecx,esi ; ecx =  string length + 1
    add  ecx,80
    sub  ecx,ebx
    inc  ecx

    push ecx

    mov  esi,ebx ; beginning of next line
    add  esi,-80 ; - 80 =    of this line

    cld
    rep  movsb

    mov  [edi],byte 13
    inc  edi
    mov  [edi],byte 10
    inc  edi

    pop  eax
    pop  ecx
    add  ecx,eax
    add  ecx,2

    mov  [filelen],ecx

    mov  eax,[fileslines]
    inc  eax
    mov  [fileslines],eax

    cmp  eax,[lines]
    jge  dosave

    add  ebx,80

    jmp  sdonewline

  dosave:

    cmp  [savetohd],1
    jz   nofloppysave

    mov  eax,32           ; delete first output file
    mov  ebx,filename
    int  0x40

    mov  eax,33
    mov  ebx,filename     ; pointer to file name
    mov  ecx,0x10000      ; buffer
    mov  edx,[filelen]    ; count to write in bytes
    sub  edx,0x10000+2
    xor  esi,esi          ; 0 create new , 1 append
    int  0x40

    test eax,eax
    je   still

    call file_not_found

  nofloppysave:

    cmp  [savetohd],0
    jz   still

    mov  ecx,[filelen]
    sub  ecx,0x10000+2
    mov  [fileinfo_write+8],ecx

    mov  esi,filename
    mov  edi,pathfile_write
    mov  ecx,50
    cld
    rep  movsb

    mov  eax,58
    mov  ebx,fileinfo_write
    int  0x40

    jmp  still

   fileinfo_write:
    dd  1
    dd  0
    dd  0
    dd  0x10000
    dd  0x70000
   pathfile_write:
    times 51 db 0

  nosave:

    inc  ah
    call read_string

    jmp  still

filelen     dd  0x0
fileslines  dd  0x0

empty_work_space:
  mov  eax,32
  mov  edi,0x80000
  mov  ecx,0x300000-0x90000
  cld
  rep  stosb
  mov  edi,0x10000
  mov  ecx,0x60000
  cld
  rep  stosb
  ret


red:

    mov  ecx,80*40
    mov  edi,0x78000
    xor  eax,eax
  @@:
    mov  [edi],eax
    dec  ecx
    jnz  @b

    call drawwindow
    jmp  still


; *** END OF WAIT LOOP ***

copy_start dd 0x0
copy_count dd 0x0

key:

    mov  eax,2            ; GET KEY
    int  0x40

    cmp  ah,9             ; HELP TEXT
    jne  no_help_text
    mov  eax,13
    mov  ebx,98*65536+6*50
    mov  ecx,100*65536+112
    mov  edx,0xffffff
    int  0x40
    mov  eax,4
    mov  ebx,110*65536+110
    xor  ecx,ecx
    mov  esi,51
    mov  edx,help_text
  new_help_line:
    int  0x40
    add  ebx,10
    add  edx,esi
    cmp  [edx],byte 'x'
    jne  new_help_line
    mov  eax,10
    int  0x40
    xor  al,al
    mov  edi,0x78000
    mov  ecx,80*40
    cld
    rep  stosb
    call drawfile
    jmp  still
  no_help_text:


    cmp  ah,19            ; COPY START
    jne  no_copy_start
    mov  eax,[post]
    mov  ebx,[posy]
    imul ebx,80
    add  eax,ebx
    mov  [copy_start],eax
    jmp  still
  no_copy_start:

    cmp  ah,5             ; COPY END
    jne  no_copy_end
    cmp  [copy_start],0
    je   still
    mov  ecx,[post]
    mov  ebx,[posy]
    imul ebx,80
    add  ecx,ebx
    add  ecx,80
    cmp  ecx,[copy_count]
    jb   still
    sub  ecx,[copy_start]
    mov  [copy_count],ecx
    mov  esi,[copy_start]
    add  esi,0x80000
    mov  edi,0x2f0000
    cld
    rep  movsb
    jmp  still
  no_copy_end:

    cmp  ah,16            ; PASTE
    jne  no_copy_paste
    cmp  [copy_count],0
    je   still
    mov  eax,[copy_count]
    xor  edx,edx
    mov  ebx,80
    div  ebx
    add  [lines],eax
    mov  ecx,0x2e0000
    mov  eax,[post]
    mov  ebx,[posy]
    imul ebx,80
    add  eax,ebx
    add  eax,0x80000
    sub  ecx,eax
    mov  esi,0x2e0000
    sub  esi,[copy_count]
    mov  edi,0x2e0000
    std
    rep  movsb
    mov  esi,0x2f0000
    mov  edi,[post]
    mov  eax,[posy]
    imul eax,80
    add  edi,eax
    add  edi,0x80000
    mov  ecx,[copy_count]
    cld
    rep  movsb
    call drawfile
    jmp  still
  no_copy_paste:

    cmp  ah,4
    jne  no_delete_line
    mov  eax,[post]
    xor  edx,edx
    mov  ebx,80
    div  ebx
    add  eax,[posy]
    inc  eax
    cmp  eax,[lines]
    jge  still
    dec  dword [lines]
    mov  edi,[posy]
    imul edi,80
    add  edi,[post]
    add  edi,0x80000
    mov  esi,edi
    add  esi,80
    mov  ecx,0x2e0000
    sub  ecx,esi
    cld
    rep  movsb
    call drawfile
    jmp  still
  no_delete_line:


    cmp  ah,13            ; enter
    jz   enter1
    jmp  noenter

   enter1:

    ; lines down

    xor  edx,edx
    mov  eax,[posy]
    inc  eax
    mov  ebx,80
    mul  ebx
    add  eax,0x80000
    add  eax,[post]
    dec  eax
    mov  ebx,eax

    xor  edx,edx
    mov  eax,[lines]
    mov  ecx,80
    mul  ecx
    add  eax,0x80000
    add  eax,[post]
    dec  eax
    mov  ecx,eax

    cmp  ebx,ecx
    jz   bug_fixed

   mnl:

    mov  dl,[ecx]
    mov  [ecx+80],dl
    dec  ecx

    cmp  ecx,ebx
    jnz  mnl

bug_fixed:

    ; save for later

    xor  edx,edx
    mov  eax,[posy]
    mov  ebx,80
    mul  ebx
    add  eax,0x80000
    add  eax,[post]
    add  eax,[posx]
    dec  eax
    mov  ebx,eax

    push ebx


    ; empty line


    mov  [posx],dword 0
    mov  ecx,[posy]
    inc  ecx
    mov  [posy],ecx

    xor  edx,edx
    mov  eax,[posy]
    mov  ebx,80
    mul  ebx
    add  eax,0x80000
    add  eax,[post]
    add  eax,[posx]
    dec  eax
    mov  ebx,eax

    mov  ecx,ebx
    add  ecx,80

   enz:
    mov  [ebx],byte 32
    inc  ebx
    cmp  ecx,ebx
    jnz  enz



    ; end of line to next line beginning

    xor  edx,edx
    mov  eax,[posy]
    mov  ebx,80
    mul  ebx
    add  eax,0x80000
    add  eax,[post]
    add  eax,[posx]
    dec  eax
    mov  ebx,eax

    pop  esi
    mov  edi,ebx

    inc  esi
    inc  ebx

   enz2:
    mov  dl,[esi]
    mov  [ebx],dl
    mov  [esi],byte 32

    inc  esi
    inc  ebx

    cmp  esi,edi
    jb   enz2

    mov  ecx,[lines]
    inc  ecx
    mov  [lines],ecx

    mov  ecx,[posy]
    cmp  ecx,[slines]
    jz   osc
    call drawfile
    jmp  still
  osc:
    dec  ecx
    mov  [posy],ecx
    mov  ecx,[post]
    add  ecx,80
    mov  [post],ecx
    call drawfile
    jmp  still
  noenter:

    cmp  ah,130+48        ; up
    jnz  noup
    mov  ecx,[posy]
    test ecx,ecx
    jnz  up1
    mov  ecx,[post]
    test ecx,ecx
    jnz  up2
    jmp  still
  up2:
    sub  ecx,80
    mov  [post],ecx
    call drawfile
    jmp  still
  up1:
    dec  ecx
    mov  [posy],ecx
    call drawfile
    jmp  still
  noup:

    cmp  ah,129+48        ; down
    jnz  nodown
    mov  ecx,[posy]
    mov  eax,[slines]
    dec  eax
    cmp  ecx,eax
    jb   do1
    mov  ecx,[post]
    mov  eax,[lines]
    sub  eax,[slines]
    dec  eax
    mov  ebx,80
    mul  ebx
    cmp  ecx,eax
    jbe  do2
    jmp  still
  do2:
    add  ecx,80
    mov  [post],ecx
    call drawfile
    jmp  still
  do1:
    pusha
    mov  eax,[post]
    xor  edx,edx
    mov  ebx,80
    div  ebx
    add  eax,[posy]
    inc  eax
    cmp  eax,[lines]
    jb   do10
    popa
    jmp  still
  do10:
    popa
    cld
    inc  ecx
    mov  [posy],ecx
    call drawfile
    jmp  still
  nodown:

    cmp  ah,128+48        ; left
    jnz  noleft
    mov  ecx,[posx]
    xor  edx,edx
    cmp  ecx,edx
    jnz  le1
    jmp  still
  le1:
    dec  ecx
    mov  [posx],ecx
    call drawfile
    jmp  still
  noleft:

    cmp  ah,131+48        ; right
    jnz  noright
    mov  ecx,[posx]
    mov  edx,79
    cmp  ecx,edx
    jnz  ri1
    jmp  still
  ri1:
    inc  ecx
    mov  [posx],ecx
    call drawfile
    jmp  still
  noright:


    cmp  ah,136+48        ; Page up
    jnz  nopu
    mov  eax,[slines]
    dec  eax
    imul eax,80
    mov  ecx,[post]
    cmp  eax,ecx
    jbe  pu1
    mov  ecx,eax
   pu1:
    sub  ecx,eax
    mov  [post],ecx
    call drawfile
    jmp  still
  nopu:

    cmp  ah,135+48        ; Page down
    jnz  nopd
    mov  eax,[post]
    xor  edx,edx
    mov  ebx,80
    div  ebx
    mov  ecx,[lines]
    cmp  eax,ecx
    jb   pdok
    jmp  still
  pdok:
    mov  eax,[slines]
    dec  eax
    imul eax,80
    add  eax,[post]
    mov  [post],eax

    mov  eax,[lines]
    sub  eax,[slines]
    xor  edx,edx
    mov  ebx,80
    mul  ebx
    mov  ebx,[post]
    cmp  ebx,eax
    jb   pdok2
    mov  [post],eax
  pdok2:
    call drawfile
    jmp  still
  nopd:



    cmp  ah,132+48        ; home
    jnz  nohome
    xor  ecx,ecx
    mov  [posx],ecx
    call drawfile
    jmp  still
  nohome:


    cmp  ah,133+48        ; end
    jnz  noend
    mov  ecx,80
    xor  edx,edx
   ke1:
    dec  ecx
    mov  [posx],ecx
    test ecx,ecx
    jz   ke2

    push eax ecx edx

    xor  edx,edx
    mov  eax,[posy]
    mov  ebx,80
    mul  ebx
    add  eax,0x80000
    add  eax,[post]
    add  eax,[posx]
    dec  eax
    mov  ebx,eax

    pop  edx ecx eax

    mov  dl,[ebx]
    mov  eax,33
    cmp  edx,eax
    jb   ke1

   ke2:
    call drawfile
    jmp  still
  noend:


    cmp  ah,134+48        ; Delete
    jz   yesdel
    jmp  nodel

  yesdel:

    xor  edx,edx
    mov  eax,[posy]
    mov  ebx,80
    mul  ebx
    add  eax,0x80000
    add  eax,[post]
    add  eax,[posx]
    mov  ebx,eax

    push ebx

    xor  edx,edx
    mov  eax,[posy]
    mov  ebx,80
    mul  ebx
    add  eax,0x80000+79
    add  eax,[post]
    mov  ebx,eax

    pop  ecx

    push ebx

    dec  ecx
    dec  ebx


    push ecx
    push ebx

    xor  edx,edx
    mov  eax,[posy]
    mov  ecx,80
    mul  ecx
    add  eax,0x80000
    add  eax,[post]
    mov  ecx,eax

    xor  edx,edx
    xor  eax,eax

    dec  ecx

   key12:
    inc  ecx
    mov  dh,[ecx]
    cmp  dh,33
    jb   nok
    xor  eax,eax
    inc  eax
  nok:
    cmp  ecx,ebx
    jb   key12

    pop  ebx
    pop  ecx


   key123:
    inc  ecx
    mov  dl,[ecx+1]
    mov  [ecx],dl
    cmp  ecx,ebx
    jb   key123


    pop  ebx
    mov  [ebx],byte 32

    test eax,eax
    jz   dellinesup

    call drawfile
    jmp  still

  dellinesup:

    ; lines -1

    pusha

    mov  eax,[post]
    xor  edx,edx
    mov  ebx,80
    div  ebx
    add  eax,[posy]
    inc  eax

    cmp  eax,[lines]
    jb   dli1

    popa

    jmp  still

  dli1:

    popa

    dec  [lines]

    ; lines up

    mov  [posx],dword 0

    xor  edx,edx
    mov  eax,[posy]
    mov  ebx,80
    mul  ebx
    add  eax,0x80000
    add  eax,[post]
    dec  eax
    mov  ebx,eax

    xor  edx,edx
    mov  eax,[lines]
    mov  ecx,80
    mul  ecx
    add  eax,0x80000
    add  eax,[post]
    dec  eax
    mov  ecx,eax

   mnlu:

    mov  dl,[ebx+80]
    mov  [ebx],dl
    inc  ebx

    cmp  ecx,ebx
    jnz  mnlu

    call drawfile
    jmp  still

  nodel:



    cmp  ah,137+48        ; Insert
    jnz  noins

    xor  edx,edx
    mov  eax,[posy]
    mov  ebx,80
    mul  ebx
    add  eax,0x80000
    add  eax,[post]
    add  eax,[posx]
    mov  ebx,eax

    push ebx

    xor  edx,edx
    mov  eax,[posy]
    mov  ebx,80
    mul  ebx
    add  eax,0x80000+79
    add  eax,[post]
    mov  ebx,eax

    pop  ecx

   key1234:
    dec  ebx
    mov  dl,[ebx]
    mov  [ebx+1],dl
    cmp  ecx,ebx
    jb   key1234

    mov  [ecx],byte 32

    call drawfile
    jmp  still

  noins:



    cmp  ah,8            ; Backspace
    jz   conbs2
    jmp  nobs
  conbs2:
    mov  ecx,[posx]
    test ecx,ecx
    jnz  conbs
    jmp  still
  conbs:
    dec  ecx
    mov  [posx],ecx

    xor  edx,edx
    mov  eax,[posy]
    mov  ebx,80
    mul  ebx
    add  eax,0x80000
    add  eax,[post]
    add  eax,[posx]
    mov  ebx,eax

    push ebx

    xor  edx,edx
    mov  eax,[posy]
    mov  ebx,80
    mul  ebx
    add  eax,0x80000+79
    add  eax,[post]
    mov  ebx,eax

    pop  ecx

    push ebx

    dec  ecx
   key124:
    inc  ecx
    mov  dl,[ecx+1]
    mov  [ecx],dl
    cmp  ecx,ebx
    jb   key124

    pop  ebx
    mov  [ebx],byte ' ' ; (!!!) 0

    call drawfile
    jmp  still

  nobs:

    push eax            ; add key

    xor  edx,edx
    mov  eax,[posy]
    mov  ebx,80
    mul  ebx
    add  eax,0x80000
    add  eax,[post]
    add  eax,[posx]
    mov  ebx,eax
;   ebx = [posy]*80+0x80000+[post]+[posx] = current position in the file

    push ebx
    push ebx

    xor  edx,edx
    mov  eax,[posy]
    mov  ebx,80
    mul  ebx
    add  eax,0x80000+79
    add  eax,[post]
    mov  ebx,eax
;     ebx = [posy]*80+0x80000+79+[post]

    pop  ecx

   key1:
    dec  ebx
    mov  dl,[ebx]
    mov  [ebx+1],dl
    cmp  ecx,ebx
    jbe  key1

    pop  ebx

    pop  eax

    mov  [ebx],ah
    mov  edx,78
    mov  ecx,[posx]
    cmp  edx,ecx
    jb   noxp
    inc  ecx
    mov  [posx],ecx
  noxp:

    call drawfile
    jmp  still




; **********************************
; **********  DRAWWINDOW  **********
; **********************************

dstart dd 0

drawwindow:


    mov  eax,12                    ; WINDOW DRAW START
    mov  ebx,1
    int  0x40

    mov  eax,48
    mov  ebx,3
    mov  ecx,system_colours
    mov  edx,10*4
    int  0x40

    xor  eax,eax                   ; DEFINE WINDOW
    mov  ebx,90*65536+496
    mov  ecx,45*65536+355
    mov  edx,[w_work]
    add  edx,0x02000000
    mov  esi,[w_grab]
    or   esi,0x80000000
    mov  edi,[w_frame]
    int  0x40

    mov  eax,8                     ; CLOSE BUTTON
    mov  ebx,(496-19)*65536+12
    mov  ecx,5*65536+12
    xor  edx,edx
    inc  edx
    mov  esi,[w_grab_button]
    int  0x40

    mov  eax,4                     ; HEADER STRING
    mov  ebx,10*65536+8
    mov  ecx,[w_grab_text]
    mov  edx,htext
    mov  esi,htextlen-htext
    int  0x40

    mov  eax,9     ; get info about me
    mov  ebx,I_END
    or   ecx,-1
    int  0x40

    mov  eax,[I_END+46] ; y size
    mov  [temp],eax

    cmp  eax,100
    jb   no_draw ; do not draw text & buttons if height < 100
    add  eax,-80
    xor  edx,edx
    mov  ebx,10
    div  ebx
    mov  [slines],eax

    mov  eax,[temp] ; calculate buttons position
    add  eax,-47
    mov  [dstart],eax

    mov  eax,13                    ; BAR STRIPE
    mov  ebx,62*65536+486-57-119
    mov  ecx,[dstart]
    add  ecx,29
    shl  ecx,16
    inc  ecx
    mov  edx,[w_work_graph]
    int  0x40

    mov  eax,8                     ; STRING BUTTON
    mov  ebx,5*65536+57
    mov  ecx,[dstart]
    add  ecx,29
    shl  ecx,16
    add  ecx,13
    mov  edx,51
    mov  esi,[w_work_button]
    int  0x40

                                   ; SEARCH BUTTON
    mov  ebx,(485-119)*65536+125
    mov  edx,50
    mov  esi,[w_work_button]
    int  0x40

    mov  eax,4                     ; SEARCH TEXT
    mov  ebx,[dstart]
    add  ebx,6*65536+32
    mov  ecx,0xffffff
    mov  edx,searcht
    mov  esi,searchtl-searcht
    int  0x40

    mov  eax,13                    ; BAR STRIPE
    mov  ebx,6*65536+486
    mov  ecx,[dstart]
    shl  ecx,16
    add  ecx,15
    mov  edx,[w_work_graph]
    int  0x40

    mov  eax,8                     ; SAVE BUTTON
    mov  ebx,(485-119)*65536+125
    mov  ecx,[dstart]
    inc  ecx
    shl  ecx,16
    add  ecx,13
    mov  edx,2
    mov  esi,[w_work_button]
    int  0x40

    mov  eax,4                     ; FIRST TEXT LINE (POSITION...)
    mov  ebx,12*65536
    add  ebx,[dstart]
    add  ebx,4
    mov  ecx,[w_work_button_text]
    mov  edx,htext2
    mov  esi,htextlen2-htext2
    int  0x40


    mov  eax,8                     ; FILE BUTTON
    mov  ebx,5*65536+57 ;75
    mov  ecx,[dstart]
    add  ecx,15
    shl  ecx,16
    add  ecx,13
    mov  edx,5
    mov  esi,[w_work_button]
    int  0x40

    mov  ebx,(485-119)*65536+125   ; LOAD BUTTON
    mov  ecx,[dstart]
    add  ecx,15
    shl  ecx,16
    add  ecx,13
    mov  edx,4
    int  0x40

    mov  eax,4                     ; SECOND TEXT LINE (FILE...)
    mov  ebx,12*65536
    add  ebx,[dstart]
    add  ebx,18
    mov  ecx,[w_work_button_text]
    mov  edx,savetext
    mov  esi,savetextlen-savetext
    int  0x40

    mov  edi,0x78000
    mov  ecx,80*80
    mov  eax,1
    cld
    rep  stosb

    call drawfile

    mov  eax,[dstart]
    add  eax,17
    mov  [ya],eax
    mov  [addr],filename
    call print_text

    add  eax,14
    mov  [ya],eax
    mov  [addr],search_string
    call print_text

no_draw:

    mov  eax,12                    ; WINDOW DRAW END
    mov  ebx,2
    int  0x40

    ret


; **********************************
; ***********  DRAWFILE  ***********
; **********************************



drawfile:

    mov  eax,[post] ; print from position

    pusha

    mov  edi,[post]
    mov  [posl],edi

    mov  ebx,8*65536+26    ; letters
    xor  ecx,ecx

    mov  edx,0x80000
    add  edx,eax
    mov  edi,edx

    mov  esi,80
    imul esi,[slines]
    add  edi,esi


  nd:

    pusha

    mov       edx,ebx
    mov       edi,edx
    add       edi,(6*65536)*80

  wi1:


    ; draw ?


    pusha

    push      ebx edx ecx

    xor       edx,edx
    mov       eax,[posx]
    mov       ebx,6
    mul       ebx
    add       eax,8
    shl       eax,16
    mov       ecx,eax

    xor       edx,edx
    mov       eax,[posy]
    mov       ebx,10
    mul       ebx
    add       eax,26
    add       eax,ecx

    pop       ecx edx ebx

    cmp       edx,eax
    jnz       drwa

    mov       eax,0x7ffff
    jmp       drlet

  drwa:

    popa


    pusha

    push      ebx edx ecx

    xor       edx,edx
    mov       eax,[posxm]
    mov       ebx,6
    mul       ebx
    add       eax,8
    shl       eax,16
    mov       ecx,eax

    xor       edx,edx
    mov       eax,[posym]
    mov       ebx,10
    mul       ebx
    add       eax,26
    add       eax,ecx

    pop       ecx edx ebx

    cmp       edx,eax
    jnz       drwa2

    mov       eax,0x7ffff
    jmp       drlet

  drwa2:

    popa



    pusha

    mov       eax,0x78000
    mov       ebx,[posl]
    add       eax,ebx
    mov       ebx,[post]
    sub       eax,ebx

    mov       edx,0x80000
    mov       ebx,[posl]
    add       edx,ebx

    mov       bl,[edx]
    mov       cl,[eax]
    cmp       bl,cl
    jnz       drlet

    popa

    jmp       nodraw


    ; draw letter


  drlet:

    mov       [eax],bl

    popa

    mov       ebx,[w_work]

    push      ebx edx ecx

    xor       edx,edx
    mov       eax,[posx]
    mov       ebx,6
    mul       ebx
    add       eax,8
    shl       eax,16
    mov       ecx,eax

    xor       edx,edx
    mov       eax,[posy]
    mov       ebx,10
    mul       ebx
    add       eax,26
    add       eax,ecx

    pop       ecx edx ebx

    cmp       edx,eax
    jnz       drw
    mov       ebx,0x00ffff
  drw:

    pusha                      ; draw bar
    push      ebx
    mov       eax,13
    mov       ebx,edx
    mov       bx,6
    mov       ecx,edx
    shl       ecx,16
    mov       cx,10
    pop       edx
    int       0x40
    popa

    pusha

    mov       eax,4                  ; text
    mov       ebx,edx ; x & y
    mov       ecx,[w_work_text]
    xor       esi,esi
    inc       esi

    mov       edx,0x80000
    mov       edi,[posl]
    add       edx,edi

    int       0x40

    popa

  nodraw:

    mov       eax,[posl]
    inc       eax
    mov       [posl],eax

    add       edx,6*65536
    cmp       edx,edi
    jz        wi3
    jmp       wi1

  wi3:

    popa

    add       ebx,10
    add       edx,80
    cmp       edi,edx
    jbe       nde
    jmp       nd

  nde:

    mov       eax,[posx]
    mov       ebx,[posy]

    mov       [posxm],eax
    mov       [posym],ebx

    popa

    ret



; **********************************
; ***********  LOADFILE  ***********
; **********************************

fileinfo_read:

     dd  0
     dd  0
     dd  300000/512
     dd  0x10000
     dd  0x70000
pathfile_read:
     times 51 db 0


loadhdfile:

     mov  esi,filename
     mov  edi,pathfile_read
     mov  ecx,50
     cld
     rep  movsb

     mov  eax,58
     mov  ebx,fileinfo_read
     int  0x40

     xchg eax,ebx

     test ebx,ebx
     je   filefound
     cmp  ebx,5
     je   filefound

     call file_not_found
     ret

loadfile:

    mov  eax,6      ; 6 = open file
    mov  ebx,filename
    xor  ecx,ecx
    mov  edx,16800
    mov  esi,0x10000
    int  0x40

    inc  eax
    jnz  filefound

    call file_not_found
    ret

  filefound:

    dec  eax
    mov  [filesize],eax

    mov  edi,0x80000
  new32:
    mov  [edi],byte 32
    inc  edi
    mov  edx,0x2effff
    cmp  edi,edx
    jnz  new32


    mov  edi,0x10000
    mov  ebx,0x80000

newline:

    xor  ecx,ecx
    inc  ecx

  newcheck:

    inc  ecx
    inc  edi

    mov  edx,[edi]
    and  edx,255
    mov  eax,10
    cmp  edx,eax
    jz   drawline

    mov  eax,80
    cmp  ecx,eax
    jbe  newcheck

    inc  ecx
    jmp  drawline


; ecx length
; edi position
; ebx position at 0x80000


  drawline:

    pusha

    mov       esi,ecx
    and       esi,127
    dec       esi
    mov       edx,edi
    mov       eax,esi
    sub       edx,eax

    pusha
    mov       eax,ebx
    add       eax,esi
    dec       eax
    dec       eax
    jz        nl2
    inc       eax

  nl1:
    mov       cl,[edx]
    cmp       cl,byte 15
    jb        novalidchar
    mov       [ebx],cl
  novalidchar:
    inc       edx
    inc       ebx

    mov       ecx,0x10000-1
    add       ecx,[filesize]
    cmp       edx,ecx
    jbe       frok
    jmp       nl2
  frok:
    cmp       ebx,eax
    jb        nl1
  nl2:

    popa
    popa

    inc       edi
    add       ebx,80

    mov       eax,0x10000
    add       eax,[filesize]
    cmp       eax,edi
    jb        endload

    jmp       newline

  endload:

    add       ebx,-0x80000
    mov       eax,ebx
    xor       edx,edx
    mov       ebx,80
    div       ebx

    mov       [lines],eax

    ret


file_not_found:

   mov  eax,13
   mov  ebx,6*65536+15
   mov  ecx,23*65536+15
   mov  edx,0xff0000
   int  0x40

   push ebx
   mov  eax,5
   mov  ebx,33
   int  0x40
   pop  ebx

   mov  eax,13
   mov  edx,[w_work]
   int  0x40

   mov  [lines],1

   ret


; *****************************
; ******  WRITE POSITION ******
; *****************************


writepos:


    pusha

    mov  eax,[posx]
    inc  eax
    xor  edx,edx
    mov  ebx,10
    div  ebx
    add  al,48
    add  dl,48
    mov  [htext2+ 9],al
    mov  [htext2+10],dl

    mov  eax,[post]
    xor  edx,edx
    mov  ebx,80
    div  ebx
    add  eax,[posy]
    inc  eax
    mov  ebx,10
    xor  edx,edx
    div  ebx
    add  dl,48
    mov  [htext2+16],dl  ; 00001
    xor  edx,edx
    div  ebx
    add  dl,48
    mov  [htext2+15],dl  ; 00010
    xor  edx,edx
    div  ebx
    add  dl,48
    mov  [htext2+14],dl  ; 00100
    xor  edx,edx
    div  ebx
    add  dl,48
    add  al,48
    mov  [htext2+13],dl  ; 01000
    mov  [htext2+12],al  ; 10000


    mov  eax,[lines]               ; number of lines
    xor  edx,edx
    mov  ebx,10
    div  ebx
    add  dl,48
    mov  [htext2+31],dl  ; 0001
    xor  edx,edx
    div  ebx
    add  dl,48
    mov  [htext2+30],dl
    xor  edx,edx
    div  ebx
    add  dl,48
    mov  [htext2+29],dl  ; 0100
    xor  edx,edx
    div  ebx
    add  dl,48
    add  al,48
    mov  [htext2+28],dl
    mov  [htext2+27],al  ; 10000

    mov  eax,13                    ; draw bar
    mov  ebx,5*65536+38*6
    mov  ecx,[dstart]
    shl  ecx,16
    mov  cx,15
    mov  edx,[w_work_graph]
    int  0x40

    mov  eax,dword 0x00000004      ; write position
    mov  ebx,12*65536
    mov  bx,word [dstart]
    add  bx,4
    mov  ecx,[w_work_button_text]
    mov  edx,htext2
    mov  esi,38
    int  0x40

    popa

    ret

; ****************************
; ******* READ STRING ********
; ****************************


read_string:

    cmp  ah,5
    jz   f1
    cmp  ah,51
    jz   f2
    ret

  f1:
    mov  [addr],dword filename
    mov  eax,[dstart]
    add  eax,17
    mov  [ya],eax
    mov  [search_enter],0
    jmp  rk
  f2:
    mov  [addr],dword search_string
    mov  eax,[dstart]
    add  eax,17+14
    mov  [ya],eax
    mov  [search_enter],1
    mov  [search_s_length],0
    jmp  rk

  rk:
    mov  edi,[addr]
    mov  al,'_'
    mov  ecx,50
    rep  stosb

    call print_text

    mov  edi,[addr]

  f11:
    mov  eax,10
    int  0x40
    cmp  eax,2
    jne  read_done
   ;mov  eax,2
    int  0x40
    shr  eax,8
    cmp  eax,13
    je   read_done
    cmp  eax,8
    jnz  nobsl
    cmp  edi,[addr]
    jz   f11
    dec  edi
    mov  [edi],byte '_'
    cmp  [search_enter],1
    jnz  @f
    dec  [search_s_length]

 @@:
    call print_text
    jmp  f11
  nobsl:
    cmp  eax,dword 31
    jbe  f11
    cmp  [search_enter],1
    je   keyok
    cmp  eax,dword 95
    jb   keyok
    add  eax,-32
   keyok:
    mov  [edi],al

    cmp  [search_enter],1
    jnz  @f
    inc  [search_s_length]
 @@:
    call print_text

    inc  edi
    mov  esi,[addr]
    add  esi,50
    cmp  esi,edi
    jnz  f11

  read_done:

    mov  ecx,[addr]
    add  ecx,50
    sub  ecx,edi
    mov  eax,32
    cld
    rep  stosb

    call print_text

    ret

print_text:

    pusha

    mov  eax,13
    mov  ebx,66*65536+50*6
    mov  ecx,[ya]
    shl  ecx,16
    add  ecx,11
    mov  edx,[w_work]
    int  0x40

    mov  edx,[addr]
    mov  ebx,66*65536+2
    add  ebx,[ya]
    mov  edi,50
   pt1:
    mov  eax,4
    mov  ecx,[w_work_text]
    mov  esi,1
    int  0x40
    cmp  [edx],byte '_'
    je   pt2
    inc  edx
    add  ebx,6*65536
    dec  edi
    jnz  pt1
   pt2:

    popa

    ret


  nof12:

    ret


; **********
; *  DATA  *
; **********

addr   dd  filename

filename        db   'SYSFUNCR.TXT                                      '
search_string   db   'still                                             '
search_s_length dd   5
search_enter    db   0

htext:
    db   'TINYPAD                              '
    db   '                CTRL-I:INFO'
htextlen:

searcht:
    db   ' STRING >                              '
    db   '                             SEARCH'
searchtl:

htext2:
    db   'POSITION 00:00000   LENGTH 00000 LINES '
    db   '                             SAVE'
htextlen2:

savetext:
    db   ' FILE  >                               '
    db   '                             LOAD'
savetextlen:

;htext3:
;    db   'GIVE NAME     LOAD FILE    EDIT TEXT   '
;    db   '                                       '
;htextlen3:

path db 0

xx  db   'x'

help_text:

    db   'COMMANDS:                                          '
    db   '                                                   '
    db   '  CTRL-S : COPY START POSITION                     '
    db   '  CTRL-E : COPY END POSITION                       '
    db   '  CTRL-P : PASTE SELECTED TO CURRENT POSITION      '
    db   '                                                   '
    db   '  CTRL-D : DELETE CURRENT LINE                     '
    db   'x'

I_PARAM db 0

macro align value { rb (value-1)-($+value-1) mod value }
align 32

IMAGE_END:

posx   dd ?  ; x coord
posy   dd ?  ; y coord
post   dd ?  ; align
posl   dd ?  ;
lines  dd ?  ;
posxm  dd ?  ;
posym  dd ?  ;

temp   dd ?

filesize dd ?
ya       dd ?
slines   dd ?

align 32

system_colours:
w_frame            dd ?
w_grab             dd ?
w_grab_button      dd ?
w_grab_button_text dd ?
w_grab_text        dd ?
w_work             dd ?
w_work_button      dd ?
w_work_button_text dd ?
w_work_text        dd ?
w_work_graph       dd ?

I_END:
